import { IRenderMimeRegistry } from '@jupyterlab/rendermime';
import { IRenderMime } from '@jupyterlab/rendermime-interfaces';
import { Widget } from '@lumino/widgets';
/**
 * A widget for rendering IPython object.
 */
export declare class OutputWidget extends Widget implements IRenderMime.IRenderer {
    /**
     * Construct a new output widget.
     */
    constructor(rendermime: IRenderMimeRegistry | null, options: IRenderMime.IRendererOptions);
    handleExpansion(data: any, parentNode: Node, shallow: boolean, expanded: boolean): Node;
    processSequenceNode(d: Record<string, any>, i: number, n: Element, expanded: boolean): void;
    processMappingNode(d: any[], i: number, n: Element, expanded: boolean): void;
    collectionFormatter(type: string, startDelim: string, endDelim: string, processNode: Function, lenOptions?: {
        [name: string]: {
            [name: string]: any;
        };
    }): (data: any, expanded?: boolean, shallow?: boolean) => HTMLSpanElement;
    numberFormatter(data: any, expanded?: boolean, shallow?: boolean): HTMLSpanElement;
    bigintFormatter(data: any, expanded?: boolean, shallow?: boolean): HTMLSpanElement;
    reprFormatter(data: any, expanded?: boolean, shallow?: boolean): HTMLSpanElement;
    defaultReprFormatter(data: any, expanded?: boolean, shallow?: boolean): HTMLSpanElement;
    mimeBundleFormatter(data: any, expanded?: boolean, shallow?: boolean): HTMLSpanElement;
    stringFormatter(data: any, expanded?: boolean, shallow?: boolean): HTMLSpanElement;
    booleanFormatter(data: any, expanded?: boolean, shallow?: boolean): HTMLSpanElement;
    nullFormatter(data: any, expanded?: boolean, shallow?: boolean): HTMLSpanElement;
    formatters: {
        [formatType: string]: Function;
    };
    processData(data: any, expanded?: boolean, shallow?: boolean): any;
    /**
     * Render IPython object into this widget's node.
     */
    renderModel(model: IRenderMime.IMimeModel): Promise<void>;
    private _mimeType;
    private _rendermime;
}
export declare const bogusRendererFactory: IRenderMime.IRendererFactory;
declare const extension: {
    id: string;
    requires: import("@lumino/coreutils").Token<IRenderMimeRegistry>[];
    autoStart: boolean;
    activate: (app: import("@jupyterlab/application").JupyterFrontEnd<import("@jupyterlab/application").JupyterFrontEnd.IShell>, tracker: import("@jupyterlab/apputils").WidgetTracker<import("@jupyterlab/docregistry").MimeDocument>, rendermime: IRenderMimeRegistry) => void;
};
export default extension;
